Index: channels/chan_sip.c
===================================================================
--- channels/chan_sip.c	(revision 115510)
+++ channels/chan_sip.c	(working copy)
@@ -12101,8 +12101,18 @@
 {
 	struct sip_pvt *p = (struct sip_pvt *) data;
 
-	ast_set_flag(&p->flags[0], SIP_NEEDREINVITE);	
+	ast_mutex_lock(&p->lock);
+
+	if (p->owner && (p->owner->_state == AST_STATE_UP) && !ast_test_flag(&p->flags[0], SIP_PENDINGBYE)) {
+		if (option_debug)
+			ast_log(LOG_DEBUG, "Sending pending reinvite retry on '%s'\n", p->callid);
+		transmit_reinvite_with_sdp(p);
+	}
+
 	p->waitid = -1;
+
+	ast_mutex_unlock(&p->lock);
+
 	return 0;
 }
 
@@ -12420,7 +12430,7 @@
 				 * Reset the flag after a while 
 				 */
 				int wait = 3 + ast_random() % 5;
-				p->waitid = ast_sched_add(sched, wait, sip_reinvite_retry, p); 
+				p->waitid = ast_sched_add(sched, wait * 1000, sip_reinvite_retry, p); 
 				if (option_debug > 2)
 					ast_log(LOG_DEBUG, "Reinvite race. Waiting %d secs before retry\n", wait);
 			}
